summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rwxr-xr-x.local/bin/dmotp21
1 files changed, 21 insertions, 0 deletions
diff --git a/.local/bin/dmotp b/.local/bin/dmotp
new file mode 100755
index 0000000..9744bc7
--- /dev/null
+++ b/.local/bin/dmotp
@@ -0,0 +1,21 @@
+#!/bin/sh
+
+if [ -n "$WAYLAND_DISPLAY" ]; then
+ dmenu=dmenu-wl
+ xdotool="ydotool type --file -"
+elif [ -n "$DISPLAY" ]; then
+ dmenu=dmenu
+ xdotool="xdotool type --delay 15 --clearmodifiers --file -"
+else
+ echo "Error: No Wayland or X11 display detected" >&2
+ exit 1
+fi
+
+prefix=${PASSWORD_STORE_DIR-~/.local/share/pass}/otp
+rprefix=$(printf "%s" $prefix | sed 's/\//\\\//g')
+password_files=$(ls "$prefix"/*.gpg | sed 's/^'${rprefix}'\///g' | sed 's/\.gpg//g')
+password=$(printf "%s\n" "${password_files}" | "$dmenu" -i -l 15 -m 0)
+
+[ -n "$password" ] || exit
+
+pass otp show otp/"$password" | { IFS= read -r pass; printf %s "$pass"; } | $xdotool